/* this file was generated by the MCOP idl compiler - DO NOT EDIT */

#ifndef ARTSFLOW_H
#define ARTSFLOW_H

#include "common.h"

enum PortDirection {input = 0, output = 1};
enum PortDataType {audio_data = 0, string_data = 1};
enum PortConnType {conn_stream = 0, conn_event = 1, conn_property = 2};
class PortType : public Type {
public:
	PortType();
	PortType(PortDirection Direction, PortDataType DataType, PortConnType ConnType, bool isMultiPort);
	PortType(Buffer& stream);
	PortType(const PortType& copyType);
	PortType& operator=(const PortType& assignType);
	virtual ~PortType();

	PortDirection Direction;
	PortDataType DataType;
	PortConnType ConnType;
	bool isMultiPort;

// marshalling functions
	void readType(Buffer& stream);
	void writeType(Buffer& stream) const;
};

class PortDesc : public Type {
public:
	PortDesc();
	PortDesc(long ID, const std::string& Name, const PortType& Type, bool isConnected, bool hasValue, const std::vector<long>& ConnectedIDs, float FloatValue, const std::string& StringValue);
	PortDesc(Buffer& stream);
	PortDesc(const PortDesc& copyType);
	PortDesc& operator=(const PortDesc& assignType);
	virtual ~PortDesc();

	long ID;
	std::string Name;
	PortType Type;
	bool isConnected;
	bool hasValue;
	std::vector<long> ConnectedIDs;
	float FloatValue;
	std::string StringValue;

// marshalling functions
	void readType(Buffer& stream);
	void writeType(Buffer& stream) const;
};

class ModuleDesc : public Type {
public:
	ModuleDesc();
	ModuleDesc(long ID, const std::string& Name, const std::vector<PortDesc *>& Ports, long X, long Y, long Width, long Height, bool isInterface, bool isStructure);
	ModuleDesc(Buffer& stream);
	ModuleDesc(const ModuleDesc& copyType);
	ModuleDesc& operator=(const ModuleDesc& assignType);
	virtual ~ModuleDesc();

	long ID;
	std::string Name;
	std::vector<PortDesc *> Ports;
	long X;
	long Y;
	long Width;
	long Height;
	bool isInterface;
	bool isStructure;

// marshalling functions
	void readType(Buffer& stream);
	void writeType(Buffer& stream) const;
};

class StructureDesc : public Type {
public:
	StructureDesc();
	StructureDesc(long Width, long Height, const std::vector<ModuleDesc *>& Modules, const std::string& Name, bool containsStructures);
	StructureDesc(Buffer& stream);
	StructureDesc(const StructureDesc& copyType);
	StructureDesc& operator=(const StructureDesc& assignType);
	virtual ~StructureDesc();

	long Width;
	long Height;
	std::vector<ModuleDesc *> Modules;
	std::string Name;
	bool containsStructures;

// marshalling functions
	void readType(Buffer& stream);
	void writeType(Buffer& stream) const;
};

class ArtsServer_base : virtual public Object {
public:
	static ArtsServer_base *_create(const std::string& subClass = "ArtsServer");
	static ArtsServer_base *_fromString(std::string objectref);
	static ArtsServer_base *_fromReference(ObjectReference ref, bool needcopy);

	inline ArtsServer_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual long createModules() = 0;
	virtual bool createModule(long mid, const ModuleDesc& desc) = 0;
	virtual bool localConnectModules(long mid) = 0;
	virtual bool finalizeModules(long mid) = 0;
	virtual void startModules(long mid) = 0;
	virtual void deleteModules(long mid) = 0;
};

typedef ReferenceHelper<ArtsServer_base> ArtsServer_var;

class ArtsServer_stub : virtual public ArtsServer_base, virtual public Object_stub {
protected:
	ArtsServer_stub();

public:
	ArtsServer_stub(Connection *connection, long objectID);

	long createModules();
	bool createModule(long mid, const ModuleDesc& desc);
	bool localConnectModules(long mid);
	bool finalizeModules(long mid);
	void startModules(long mid);
	void deleteModules(long mid);
};

class ArtsServer_skel : virtual public ArtsServer_base, virtual public Object_skel {
public:
	ArtsServer_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class ArtsServer : virtual public SmartWrapper {
protected:
	ArtsServer_base *_ArtsServer_redirect;

	inline void _assign_ArtsServer_base(ArtsServer_base *base) {
		if(_ArtsServer_redirect != 0) _ArtsServer_redirect->_release();
		_ArtsServer_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline ArtsServer_base *_ArtsServer_base() {
		if(_ArtsServer_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _ArtsServer_redirect;
	}

public:
	inline ArtsServer() : _ArtsServer_redirect(0) { /* nothing to be done*/ }
	virtual ~ArtsServer();
	inline ArtsServer(const SubClass &s) : _ArtsServer_redirect(0) {
		_assign_ArtsServer_base(ArtsServer_base::_create(s.string()));
	}
	inline ArtsServer(const Reference &r) : _ArtsServer_redirect(0) {
		_assign_ArtsServer_base(r.isString()?(ArtsServer_base::_fromString(r.string())):(ArtsServer_base::_fromReference(r.reference(),true)));
	}
	inline ArtsServer(ArtsServer& target) : _ArtsServer_redirect(0) {
		if (target._ArtsServer_redirect)
			_assign_ArtsServer_base(target._ArtsServer_base()->_copy());
	}
	inline ArtsServer& operator=(ArtsServer& target) {		if (target._ArtsServer_redirect)
			_assign_ArtsServer_base(target._ArtsServer_base()->_copy());
		return *this;
	}
	inline ArtsServer(ArtsServer_base *target) : _ArtsServer_redirect(0) {
		if (target) _assign_ArtsServer_base(target->_copy());
	}
	inline ArtsServer& operator=(ArtsServer_base *target) {
		if (target) _assign_ArtsServer_base(target->_copy());
		return *this;
	}
	inline ArtsServer(ArtsServer_var target) : _ArtsServer_redirect(0) {
		if ((ArtsServer_base *)target) _assign_ArtsServer_base(target->_copy());
	}
	inline ArtsServer& operator=(ArtsServer_var target) {
		if ((ArtsServer_base *)target) _assign_ArtsServer_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _ArtsServer_base()->_toString();}
	inline operator ArtsServer_base*() {return _ArtsServer_base();}
	inline bool isNull() {return _ArtsServer_base()==0;}

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

	inline long createModules() {return _ArtsServer_base()->createModules();}
	inline bool createModule(long mid, const ModuleDesc& desc) {return _ArtsServer_base()->createModule(mid, desc);}
	inline bool localConnectModules(long mid) {return _ArtsServer_base()->localConnectModules(mid);}
	inline bool finalizeModules(long mid) {return _ArtsServer_base()->finalizeModules(mid);}
	inline void startModules(long mid) {return _ArtsServer_base()->startModules(mid);}
	inline void deleteModules(long mid) {return _ArtsServer_base()->deleteModules(mid);}
};

class ExecutionManager_base : virtual public Object {
public:
	static ExecutionManager_base *_create(const std::string& subClass = "ExecutionManager");
	static ExecutionManager_base *_fromString(std::string objectref);
	static ExecutionManager_base *_fromReference(ObjectReference ref, bool needcopy);

	inline ExecutionManager_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual StructureDesc* expandStructureDesc(const StructureDesc& structuredesc) = 0;
	virtual long createStructure(const StructureDesc& structuredesc) = 0;
	virtual bool isExecuting(long id) = 0;
	virtual bool freeStructure(long id) = 0;
	virtual void forceTermination() = 0;
};

typedef ReferenceHelper<ExecutionManager_base> ExecutionManager_var;

class ExecutionManager_stub : virtual public ExecutionManager_base, virtual public Object_stub {
protected:
	ExecutionManager_stub();

public:
	ExecutionManager_stub(Connection *connection, long objectID);

	StructureDesc* expandStructureDesc(const StructureDesc& structuredesc);
	long createStructure(const StructureDesc& structuredesc);
	bool isExecuting(long id);
	bool freeStructure(long id);
	void forceTermination();
};

class ExecutionManager_skel : virtual public ExecutionManager_base, virtual public Object_skel {
public:
	ExecutionManager_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class ExecutionManager : virtual public SmartWrapper {
protected:
	ExecutionManager_base *_ExecutionManager_redirect;

	inline void _assign_ExecutionManager_base(ExecutionManager_base *base) {
		if(_ExecutionManager_redirect != 0) _ExecutionManager_redirect->_release();
		_ExecutionManager_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline ExecutionManager_base *_ExecutionManager_base() {
		if(_ExecutionManager_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _ExecutionManager_redirect;
	}

public:
	inline ExecutionManager() : _ExecutionManager_redirect(0) { /* nothing to be done*/ }
	virtual ~ExecutionManager();
	inline ExecutionManager(const SubClass &s) : _ExecutionManager_redirect(0) {
		_assign_ExecutionManager_base(ExecutionManager_base::_create(s.string()));
	}
	inline ExecutionManager(const Reference &r) : _ExecutionManager_redirect(0) {
		_assign_ExecutionManager_base(r.isString()?(ExecutionManager_base::_fromString(r.string())):(ExecutionManager_base::_fromReference(r.reference(),true)));
	}
	inline ExecutionManager(ExecutionManager& target) : _ExecutionManager_redirect(0) {
		if (target._ExecutionManager_redirect)
			_assign_ExecutionManager_base(target._ExecutionManager_base()->_copy());
	}
	inline ExecutionManager& operator=(ExecutionManager& target) {		if (target._ExecutionManager_redirect)
			_assign_ExecutionManager_base(target._ExecutionManager_base()->_copy());
		return *this;
	}
	inline ExecutionManager(ExecutionManager_base *target) : _ExecutionManager_redirect(0) {
		if (target) _assign_ExecutionManager_base(target->_copy());
	}
	inline ExecutionManager& operator=(ExecutionManager_base *target) {
		if (target) _assign_ExecutionManager_base(target->_copy());
		return *this;
	}
	inline ExecutionManager(ExecutionManager_var target) : _ExecutionManager_redirect(0) {
		if ((ExecutionManager_base *)target) _assign_ExecutionManager_base(target->_copy());
	}
	inline ExecutionManager& operator=(ExecutionManager_var target) {
		if ((ExecutionManager_base *)target) _assign_ExecutionManager_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _ExecutionManager_base()->_toString();}
	inline operator ExecutionManager_base*() {return _ExecutionManager_base();}
	inline bool isNull() {return _ExecutionManager_base()==0;}

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

	inline StructureDesc* expandStructureDesc(const StructureDesc& structuredesc) {return _ExecutionManager_base()->expandStructureDesc(structuredesc);}
	inline long createStructure(const StructureDesc& structuredesc) {return _ExecutionManager_base()->createStructure(structuredesc);}
	inline bool isExecuting(long id) {return _ExecutionManager_base()->isExecuting(id);}
	inline bool freeStructure(long id) {return _ExecutionManager_base()->freeStructure(id);}
	inline void forceTermination() {return _ExecutionManager_base()->forceTermination();}
};

class SynthModule_base : virtual public Object {
public:
	static SynthModule_base *_create(const std::string& subClass = "SynthModule");
	static SynthModule_base *_fromString(std::string objectref);
	static SynthModule_base *_fromReference(ObjectReference ref, bool needcopy);

	inline SynthModule_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual void firstInitialize() = 0;
	virtual void initialize() = 0;
	virtual void start() = 0;
	virtual void deInitialize() = 0;
};

typedef ReferenceHelper<SynthModule_base> SynthModule_var;

class SynthModule_stub : virtual public SynthModule_base, virtual public Object_stub {
protected:
	SynthModule_stub();

public:
	SynthModule_stub(Connection *connection, long objectID);

	void firstInitialize();
	void initialize();
	void start();
	void deInitialize();
};

class SynthModule_skel : virtual public SynthModule_base, virtual public Object_skel {
public:
	SynthModule_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class SynthModule : virtual public SmartWrapper {
protected:
	SynthModule_base *_SynthModule_redirect;

	inline void _assign_SynthModule_base(SynthModule_base *base) {
		if(_SynthModule_redirect != 0) _SynthModule_redirect->_release();
		_SynthModule_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline SynthModule_base *_SynthModule_base() {
		if(_SynthModule_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _SynthModule_redirect;
	}

public:
	inline SynthModule() : _SynthModule_redirect(0) { /* nothing to be done*/ }
	virtual ~SynthModule();
	inline SynthModule(const SubClass &s) : _SynthModule_redirect(0) {
		_assign_SynthModule_base(SynthModule_base::_create(s.string()));
	}
	inline SynthModule(const Reference &r) : _SynthModule_redirect(0) {
		_assign_SynthModule_base(r.isString()?(SynthModule_base::_fromString(r.string())):(SynthModule_base::_fromReference(r.reference(),true)));
	}
	inline SynthModule(SynthModule& target) : _SynthModule_redirect(0) {
		if (target._SynthModule_redirect)
			_assign_SynthModule_base(target._SynthModule_base()->_copy());
	}
	inline SynthModule& operator=(SynthModule& target) {		if (target._SynthModule_redirect)
			_assign_SynthModule_base(target._SynthModule_base()->_copy());
		return *this;
	}
	inline SynthModule(SynthModule_base *target) : _SynthModule_redirect(0) {
		if (target) _assign_SynthModule_base(target->_copy());
	}
	inline SynthModule& operator=(SynthModule_base *target) {
		if (target) _assign_SynthModule_base(target->_copy());
		return *this;
	}
	inline SynthModule(SynthModule_var target) : _SynthModule_redirect(0) {
		if ((SynthModule_base *)target) _assign_SynthModule_base(target->_copy());
	}
	inline SynthModule& operator=(SynthModule_var target) {
		if ((SynthModule_base *)target) _assign_SynthModule_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _SynthModule_base()->_toString();}
	inline operator SynthModule_base*() {return _SynthModule_base();}
	inline bool isNull() {return _SynthModule_base()==0;}

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

	inline void firstInitialize() {return _SynthModule_base()->firstInitialize();}
	inline void initialize() {return _SynthModule_base()->initialize();}
	inline void start() {return _SynthModule_base()->start();}
	inline void deInitialize() {return _SynthModule_base()->deInitialize();}
};

class Synth_PLAY_base : virtual public SynthModule_base {
public:
	static Synth_PLAY_base *_create(const std::string& subClass = "Synth_PLAY");
	static Synth_PLAY_base *_fromString(std::string objectref);
	static Synth_PLAY_base *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_PLAY_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_PLAY_base> Synth_PLAY_var;

class Synth_PLAY_stub : virtual public Synth_PLAY_base, virtual public SynthModule_stub {
protected:
	Synth_PLAY_stub();

public:
	Synth_PLAY_stub(Connection *connection, long objectID);

};

class Synth_PLAY_skel : virtual public Synth_PLAY_base, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *invalue_left;                      // incoming stream
	float *invalue_right;                     // incoming stream

public:
	Synth_PLAY_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"
#include "flowsystem.h"
#include "component.h"

class Synth_PLAY : virtual public Component, virtual public SynthModule {
protected:
	Synth_PLAY_base *_Synth_PLAY_redirect;

	inline void _assign_Synth_PLAY_base(Synth_PLAY_base *base) {
		if(_Synth_PLAY_redirect != 0) _Synth_PLAY_redirect->_release();
		_Synth_PLAY_redirect = base;
		_SynthModule_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline Synth_PLAY_base *_Synth_PLAY_base() {
		if(_Synth_PLAY_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _Synth_PLAY_redirect;
	}

public:
	inline Synth_PLAY() : SynthModule(), _Synth_PLAY_redirect(0) { /* nothing to be done*/ }
	virtual ~Synth_PLAY();
	inline Synth_PLAY(const SubClass &s) : SynthModule(), _Synth_PLAY_redirect(0) {
		_assign_Synth_PLAY_base(Synth_PLAY_base::_create(s.string()));
	}
	inline Synth_PLAY(const Reference &r) : SynthModule(), _Synth_PLAY_redirect(0) {
		_assign_Synth_PLAY_base(r.isString()?(Synth_PLAY_base::_fromString(r.string())):(Synth_PLAY_base::_fromReference(r.reference(),true)));
	}
	inline Synth_PLAY(Synth_PLAY& target) : SynthModule(), _Synth_PLAY_redirect(0) {
		if (target._Synth_PLAY_redirect)
			_assign_Synth_PLAY_base(target._Synth_PLAY_base()->_copy());
	}
	inline Synth_PLAY& operator=(Synth_PLAY& target) {		if (target._Synth_PLAY_redirect)
			_assign_Synth_PLAY_base(target._Synth_PLAY_base()->_copy());
		return *this;
	}
	inline Synth_PLAY(Synth_PLAY_base *target) : SynthModule(), _Synth_PLAY_redirect(0) {
		if (target) _assign_Synth_PLAY_base(target->_copy());
	}
	inline Synth_PLAY& operator=(Synth_PLAY_base *target) {
		if (target) _assign_Synth_PLAY_base(target->_copy());
		return *this;
	}
	inline Synth_PLAY(Synth_PLAY_var target) : SynthModule(), _Synth_PLAY_redirect(0) {
		if ((Synth_PLAY_base *)target) _assign_Synth_PLAY_base(target->_copy());
	}
	inline Synth_PLAY& operator=(Synth_PLAY_var target) {
		if ((Synth_PLAY_base *)target) _assign_Synth_PLAY_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _Synth_PLAY_base()->_toString();}
	inline operator Synth_PLAY_base*() {return _Synth_PLAY_base();}
	inline bool isNull() {return _Synth_PLAY_base()==0;}

	inline void start() {_Synth_PLAY_base()->_node()->start();}
	ScheduleNode *node();

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

};

class Synth_FREQUENCY_base : virtual public SynthModule_base {
public:
	static Synth_FREQUENCY_base *_create(const std::string& subClass = "Synth_FREQUENCY");
	static Synth_FREQUENCY_base *_fromString(std::string objectref);
	static Synth_FREQUENCY_base *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_FREQUENCY_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_FREQUENCY_base> Synth_FREQUENCY_var;

class Synth_FREQUENCY_stub : virtual public Synth_FREQUENCY_base, virtual public SynthModule_stub {
protected:
	Synth_FREQUENCY_stub();

public:
	Synth_FREQUENCY_stub(Connection *connection, long objectID);

};

class Synth_FREQUENCY_skel : virtual public Synth_FREQUENCY_base, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *frequency;                         // incoming stream
	float *pos;                               // outgoing stream

public:
	Synth_FREQUENCY_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"
#include "flowsystem.h"
#include "component.h"

class Synth_FREQUENCY : virtual public Component, virtual public SynthModule {
protected:
	Synth_FREQUENCY_base *_Synth_FREQUENCY_redirect;

	inline void _assign_Synth_FREQUENCY_base(Synth_FREQUENCY_base *base) {
		if(_Synth_FREQUENCY_redirect != 0) _Synth_FREQUENCY_redirect->_release();
		_Synth_FREQUENCY_redirect = base;
		_SynthModule_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline Synth_FREQUENCY_base *_Synth_FREQUENCY_base() {
		if(_Synth_FREQUENCY_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _Synth_FREQUENCY_redirect;
	}

public:
	inline Synth_FREQUENCY() : SynthModule(), _Synth_FREQUENCY_redirect(0) { /* nothing to be done*/ }
	virtual ~Synth_FREQUENCY();
	inline Synth_FREQUENCY(const SubClass &s) : SynthModule(), _Synth_FREQUENCY_redirect(0) {
		_assign_Synth_FREQUENCY_base(Synth_FREQUENCY_base::_create(s.string()));
	}
	inline Synth_FREQUENCY(const Reference &r) : SynthModule(), _Synth_FREQUENCY_redirect(0) {
		_assign_Synth_FREQUENCY_base(r.isString()?(Synth_FREQUENCY_base::_fromString(r.string())):(Synth_FREQUENCY_base::_fromReference(r.reference(),true)));
	}
	inline Synth_FREQUENCY(Synth_FREQUENCY& target) : SynthModule(), _Synth_FREQUENCY_redirect(0) {
		if (target._Synth_FREQUENCY_redirect)
			_assign_Synth_FREQUENCY_base(target._Synth_FREQUENCY_base()->_copy());
	}
	inline Synth_FREQUENCY& operator=(Synth_FREQUENCY& target) {		if (target._Synth_FREQUENCY_redirect)
			_assign_Synth_FREQUENCY_base(target._Synth_FREQUENCY_base()->_copy());
		return *this;
	}
	inline Synth_FREQUENCY(Synth_FREQUENCY_base *target) : SynthModule(), _Synth_FREQUENCY_redirect(0) {
		if (target) _assign_Synth_FREQUENCY_base(target->_copy());
	}
	inline Synth_FREQUENCY& operator=(Synth_FREQUENCY_base *target) {
		if (target) _assign_Synth_FREQUENCY_base(target->_copy());
		return *this;
	}
	inline Synth_FREQUENCY(Synth_FREQUENCY_var target) : SynthModule(), _Synth_FREQUENCY_redirect(0) {
		if ((Synth_FREQUENCY_base *)target) _assign_Synth_FREQUENCY_base(target->_copy());
	}
	inline Synth_FREQUENCY& operator=(Synth_FREQUENCY_var target) {
		if ((Synth_FREQUENCY_base *)target) _assign_Synth_FREQUENCY_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _Synth_FREQUENCY_base()->_toString();}
	inline operator Synth_FREQUENCY_base*() {return _Synth_FREQUENCY_base();}
	inline bool isNull() {return _Synth_FREQUENCY_base()==0;}

	inline void start() {_Synth_FREQUENCY_base()->_node()->start();}
	ScheduleNode *node();

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

};

class Synth_WAVE_SIN_base : virtual public SynthModule_base {
public:
	static Synth_WAVE_SIN_base *_create(const std::string& subClass = "Synth_WAVE_SIN");
	static Synth_WAVE_SIN_base *_fromString(std::string objectref);
	static Synth_WAVE_SIN_base *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_WAVE_SIN_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_WAVE_SIN_base> Synth_WAVE_SIN_var;

class Synth_WAVE_SIN_stub : virtual public Synth_WAVE_SIN_base, virtual public SynthModule_stub {
protected:
	Synth_WAVE_SIN_stub();

public:
	Synth_WAVE_SIN_stub(Connection *connection, long objectID);

};

class Synth_WAVE_SIN_skel : virtual public Synth_WAVE_SIN_base, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *pos;                               // incoming stream
	float *outvalue;                          // outgoing stream

public:
	Synth_WAVE_SIN_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"
#include "flowsystem.h"
#include "component.h"

class Synth_WAVE_SIN : virtual public Component, virtual public SynthModule {
protected:
	Synth_WAVE_SIN_base *_Synth_WAVE_SIN_redirect;

	inline void _assign_Synth_WAVE_SIN_base(Synth_WAVE_SIN_base *base) {
		if(_Synth_WAVE_SIN_redirect != 0) _Synth_WAVE_SIN_redirect->_release();
		_Synth_WAVE_SIN_redirect = base;
		_SynthModule_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline Synth_WAVE_SIN_base *_Synth_WAVE_SIN_base() {
		if(_Synth_WAVE_SIN_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _Synth_WAVE_SIN_redirect;
	}

public:
	inline Synth_WAVE_SIN() : SynthModule(), _Synth_WAVE_SIN_redirect(0) { /* nothing to be done*/ }
	virtual ~Synth_WAVE_SIN();
	inline Synth_WAVE_SIN(const SubClass &s) : SynthModule(), _Synth_WAVE_SIN_redirect(0) {
		_assign_Synth_WAVE_SIN_base(Synth_WAVE_SIN_base::_create(s.string()));
	}
	inline Synth_WAVE_SIN(const Reference &r) : SynthModule(), _Synth_WAVE_SIN_redirect(0) {
		_assign_Synth_WAVE_SIN_base(r.isString()?(Synth_WAVE_SIN_base::_fromString(r.string())):(Synth_WAVE_SIN_base::_fromReference(r.reference(),true)));
	}
	inline Synth_WAVE_SIN(Synth_WAVE_SIN& target) : SynthModule(), _Synth_WAVE_SIN_redirect(0) {
		if (target._Synth_WAVE_SIN_redirect)
			_assign_Synth_WAVE_SIN_base(target._Synth_WAVE_SIN_base()->_copy());
	}
	inline Synth_WAVE_SIN& operator=(Synth_WAVE_SIN& target) {		if (target._Synth_WAVE_SIN_redirect)
			_assign_Synth_WAVE_SIN_base(target._Synth_WAVE_SIN_base()->_copy());
		return *this;
	}
	inline Synth_WAVE_SIN(Synth_WAVE_SIN_base *target) : SynthModule(), _Synth_WAVE_SIN_redirect(0) {
		if (target) _assign_Synth_WAVE_SIN_base(target->_copy());
	}
	inline Synth_WAVE_SIN& operator=(Synth_WAVE_SIN_base *target) {
		if (target) _assign_Synth_WAVE_SIN_base(target->_copy());
		return *this;
	}
	inline Synth_WAVE_SIN(Synth_WAVE_SIN_var target) : SynthModule(), _Synth_WAVE_SIN_redirect(0) {
		if ((Synth_WAVE_SIN_base *)target) _assign_Synth_WAVE_SIN_base(target->_copy());
	}
	inline Synth_WAVE_SIN& operator=(Synth_WAVE_SIN_var target) {
		if ((Synth_WAVE_SIN_base *)target) _assign_Synth_WAVE_SIN_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _Synth_WAVE_SIN_base()->_toString();}
	inline operator Synth_WAVE_SIN_base*() {return _Synth_WAVE_SIN_base();}
	inline bool isNull() {return _Synth_WAVE_SIN_base()==0;}

	inline void start() {_Synth_WAVE_SIN_base()->_node()->start();}
	ScheduleNode *node();

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

};

class Synth_MULTI_ADD_base : virtual public SynthModule_base {
public:
	static Synth_MULTI_ADD_base *_create(const std::string& subClass = "Synth_MULTI_ADD");
	static Synth_MULTI_ADD_base *_fromString(std::string objectref);
	static Synth_MULTI_ADD_base *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_MULTI_ADD_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_MULTI_ADD_base> Synth_MULTI_ADD_var;

class Synth_MULTI_ADD_stub : virtual public Synth_MULTI_ADD_base, virtual public SynthModule_stub {
protected:
	Synth_MULTI_ADD_stub();

public:
	Synth_MULTI_ADD_stub(Connection *connection, long objectID);

};

class Synth_MULTI_ADD_skel : virtual public Synth_MULTI_ADD_base, virtual public SynthModule_skel {
protected:
	// variables for streams
	float **invalue;                          // incoming stream
	float *outvalue;                          // outgoing stream

public:
	Synth_MULTI_ADD_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"
#include "flowsystem.h"
#include "component.h"

class Synth_MULTI_ADD : virtual public Component, virtual public SynthModule {
protected:
	Synth_MULTI_ADD_base *_Synth_MULTI_ADD_redirect;

	inline void _assign_Synth_MULTI_ADD_base(Synth_MULTI_ADD_base *base) {
		if(_Synth_MULTI_ADD_redirect != 0) _Synth_MULTI_ADD_redirect->_release();
		_Synth_MULTI_ADD_redirect = base;
		_SynthModule_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline Synth_MULTI_ADD_base *_Synth_MULTI_ADD_base() {
		if(_Synth_MULTI_ADD_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _Synth_MULTI_ADD_redirect;
	}

public:
	inline Synth_MULTI_ADD() : SynthModule(), _Synth_MULTI_ADD_redirect(0) { /* nothing to be done*/ }
	virtual ~Synth_MULTI_ADD();
	inline Synth_MULTI_ADD(const SubClass &s) : SynthModule(), _Synth_MULTI_ADD_redirect(0) {
		_assign_Synth_MULTI_ADD_base(Synth_MULTI_ADD_base::_create(s.string()));
	}
	inline Synth_MULTI_ADD(const Reference &r) : SynthModule(), _Synth_MULTI_ADD_redirect(0) {
		_assign_Synth_MULTI_ADD_base(r.isString()?(Synth_MULTI_ADD_base::_fromString(r.string())):(Synth_MULTI_ADD_base::_fromReference(r.reference(),true)));
	}
	inline Synth_MULTI_ADD(Synth_MULTI_ADD& target) : SynthModule(), _Synth_MULTI_ADD_redirect(0) {
		if (target._Synth_MULTI_ADD_redirect)
			_assign_Synth_MULTI_ADD_base(target._Synth_MULTI_ADD_base()->_copy());
	}
	inline Synth_MULTI_ADD& operator=(Synth_MULTI_ADD& target) {		if (target._Synth_MULTI_ADD_redirect)
			_assign_Synth_MULTI_ADD_base(target._Synth_MULTI_ADD_base()->_copy());
		return *this;
	}
	inline Synth_MULTI_ADD(Synth_MULTI_ADD_base *target) : SynthModule(), _Synth_MULTI_ADD_redirect(0) {
		if (target) _assign_Synth_MULTI_ADD_base(target->_copy());
	}
	inline Synth_MULTI_ADD& operator=(Synth_MULTI_ADD_base *target) {
		if (target) _assign_Synth_MULTI_ADD_base(target->_copy());
		return *this;
	}
	inline Synth_MULTI_ADD(Synth_MULTI_ADD_var target) : SynthModule(), _Synth_MULTI_ADD_redirect(0) {
		if ((Synth_MULTI_ADD_base *)target) _assign_Synth_MULTI_ADD_base(target->_copy());
	}
	inline Synth_MULTI_ADD& operator=(Synth_MULTI_ADD_var target) {
		if ((Synth_MULTI_ADD_base *)target) _assign_Synth_MULTI_ADD_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _Synth_MULTI_ADD_base()->_toString();}
	inline operator Synth_MULTI_ADD_base*() {return _Synth_MULTI_ADD_base();}
	inline bool isNull() {return _Synth_MULTI_ADD_base()==0;}

	inline void start() {_Synth_MULTI_ADD_base()->_node()->start();}
	ScheduleNode *node();

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

};

class Synth_ADD_base : virtual public SynthModule_base {
public:
	static Synth_ADD_base *_create(const std::string& subClass = "Synth_ADD");
	static Synth_ADD_base *_fromString(std::string objectref);
	static Synth_ADD_base *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_ADD_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_ADD_base> Synth_ADD_var;

class Synth_ADD_stub : virtual public Synth_ADD_base, virtual public SynthModule_stub {
protected:
	Synth_ADD_stub();

public:
	Synth_ADD_stub(Connection *connection, long objectID);

};

class Synth_ADD_skel : virtual public Synth_ADD_base, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *invalue1;                          // incoming stream
	float *invalue2;                          // incoming stream
	float *outvalue;                          // outgoing stream

public:
	Synth_ADD_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"
#include "flowsystem.h"
#include "component.h"

class Synth_ADD : virtual public Component, virtual public SynthModule {
protected:
	Synth_ADD_base *_Synth_ADD_redirect;

	inline void _assign_Synth_ADD_base(Synth_ADD_base *base) {
		if(_Synth_ADD_redirect != 0) _Synth_ADD_redirect->_release();
		_Synth_ADD_redirect = base;
		_SynthModule_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline Synth_ADD_base *_Synth_ADD_base() {
		if(_Synth_ADD_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _Synth_ADD_redirect;
	}

public:
	inline Synth_ADD() : SynthModule(), _Synth_ADD_redirect(0) { /* nothing to be done*/ }
	virtual ~Synth_ADD();
	inline Synth_ADD(const SubClass &s) : SynthModule(), _Synth_ADD_redirect(0) {
		_assign_Synth_ADD_base(Synth_ADD_base::_create(s.string()));
	}
	inline Synth_ADD(const Reference &r) : SynthModule(), _Synth_ADD_redirect(0) {
		_assign_Synth_ADD_base(r.isString()?(Synth_ADD_base::_fromString(r.string())):(Synth_ADD_base::_fromReference(r.reference(),true)));
	}
	inline Synth_ADD(Synth_ADD& target) : SynthModule(), _Synth_ADD_redirect(0) {
		if (target._Synth_ADD_redirect)
			_assign_Synth_ADD_base(target._Synth_ADD_base()->_copy());
	}
	inline Synth_ADD& operator=(Synth_ADD& target) {		if (target._Synth_ADD_redirect)
			_assign_Synth_ADD_base(target._Synth_ADD_base()->_copy());
		return *this;
	}
	inline Synth_ADD(Synth_ADD_base *target) : SynthModule(), _Synth_ADD_redirect(0) {
		if (target) _assign_Synth_ADD_base(target->_copy());
	}
	inline Synth_ADD& operator=(Synth_ADD_base *target) {
		if (target) _assign_Synth_ADD_base(target->_copy());
		return *this;
	}
	inline Synth_ADD(Synth_ADD_var target) : SynthModule(), _Synth_ADD_redirect(0) {
		if ((Synth_ADD_base *)target) _assign_Synth_ADD_base(target->_copy());
	}
	inline Synth_ADD& operator=(Synth_ADD_var target) {
		if ((Synth_ADD_base *)target) _assign_Synth_ADD_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _Synth_ADD_base()->_toString();}
	inline operator Synth_ADD_base*() {return _Synth_ADD_base();}
	inline bool isNull() {return _Synth_ADD_base()==0;}

	inline void start() {_Synth_ADD_base()->_node()->start();}
	ScheduleNode *node();

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

};

class Synth_MUL_base : virtual public SynthModule_base {
public:
	static Synth_MUL_base *_create(const std::string& subClass = "Synth_MUL");
	static Synth_MUL_base *_fromString(std::string objectref);
	static Synth_MUL_base *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_MUL_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<Synth_MUL_base> Synth_MUL_var;

class Synth_MUL_stub : virtual public Synth_MUL_base, virtual public SynthModule_stub {
protected:
	Synth_MUL_stub();

public:
	Synth_MUL_stub(Connection *connection, long objectID);

};

class Synth_MUL_skel : virtual public Synth_MUL_base, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *invalue1;                          // incoming stream
	float *invalue2;                          // incoming stream
	float *outvalue;                          // outgoing stream

public:
	Synth_MUL_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"
#include "flowsystem.h"
#include "component.h"

class Synth_MUL : virtual public Component, virtual public SynthModule {
protected:
	Synth_MUL_base *_Synth_MUL_redirect;

	inline void _assign_Synth_MUL_base(Synth_MUL_base *base) {
		if(_Synth_MUL_redirect != 0) _Synth_MUL_redirect->_release();
		_Synth_MUL_redirect = base;
		_SynthModule_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline Synth_MUL_base *_Synth_MUL_base() {
		if(_Synth_MUL_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _Synth_MUL_redirect;
	}

public:
	inline Synth_MUL() : SynthModule(), _Synth_MUL_redirect(0) { /* nothing to be done*/ }
	virtual ~Synth_MUL();
	inline Synth_MUL(const SubClass &s) : SynthModule(), _Synth_MUL_redirect(0) {
		_assign_Synth_MUL_base(Synth_MUL_base::_create(s.string()));
	}
	inline Synth_MUL(const Reference &r) : SynthModule(), _Synth_MUL_redirect(0) {
		_assign_Synth_MUL_base(r.isString()?(Synth_MUL_base::_fromString(r.string())):(Synth_MUL_base::_fromReference(r.reference(),true)));
	}
	inline Synth_MUL(Synth_MUL& target) : SynthModule(), _Synth_MUL_redirect(0) {
		if (target._Synth_MUL_redirect)
			_assign_Synth_MUL_base(target._Synth_MUL_base()->_copy());
	}
	inline Synth_MUL& operator=(Synth_MUL& target) {		if (target._Synth_MUL_redirect)
			_assign_Synth_MUL_base(target._Synth_MUL_base()->_copy());
		return *this;
	}
	inline Synth_MUL(Synth_MUL_base *target) : SynthModule(), _Synth_MUL_redirect(0) {
		if (target) _assign_Synth_MUL_base(target->_copy());
	}
	inline Synth_MUL& operator=(Synth_MUL_base *target) {
		if (target) _assign_Synth_MUL_base(target->_copy());
		return *this;
	}
	inline Synth_MUL(Synth_MUL_var target) : SynthModule(), _Synth_MUL_redirect(0) {
		if ((Synth_MUL_base *)target) _assign_Synth_MUL_base(target->_copy());
	}
	inline Synth_MUL& operator=(Synth_MUL_var target) {
		if ((Synth_MUL_base *)target) _assign_Synth_MUL_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _Synth_MUL_base()->_toString();}
	inline operator Synth_MUL_base*() {return _Synth_MUL_base();}
	inline bool isNull() {return _Synth_MUL_base()==0;}

	inline void start() {_Synth_MUL_base()->_node()->start();}
	ScheduleNode *node();

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

};

class Synth_PLAY_WAV_base : virtual public SynthModule_base {
public:
	static Synth_PLAY_WAV_base *_create(const std::string& subClass = "Synth_PLAY_WAV");
	static Synth_PLAY_WAV_base *_fromString(std::string objectref);
	static Synth_PLAY_WAV_base *_fromReference(ObjectReference ref, bool needcopy);

	inline Synth_PLAY_WAV_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual float speed() = 0;
	virtual void speed(float newValue) = 0;
	virtual std::string filename() = 0;
	virtual void filename(const std::string& newValue) = 0;
	virtual bool finished() = 0;
};

typedef ReferenceHelper<Synth_PLAY_WAV_base> Synth_PLAY_WAV_var;

class Synth_PLAY_WAV_stub : virtual public Synth_PLAY_WAV_base, virtual public SynthModule_stub {
protected:
	Synth_PLAY_WAV_stub();

public:
	Synth_PLAY_WAV_stub(Connection *connection, long objectID);

	float speed();
	void speed(float newValue);
	std::string filename();
	void filename(const std::string& newValue);
	bool finished();
};

class Synth_PLAY_WAV_skel : virtual public Synth_PLAY_WAV_base, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *left;                              // outgoing stream
	float *right;                             // outgoing stream

public:
	Synth_PLAY_WAV_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"
#include "flowsystem.h"
#include "component.h"

class Synth_PLAY_WAV : virtual public Component, virtual public SynthModule {
protected:
	Synth_PLAY_WAV_base *_Synth_PLAY_WAV_redirect;

	inline void _assign_Synth_PLAY_WAV_base(Synth_PLAY_WAV_base *base) {
		if(_Synth_PLAY_WAV_redirect != 0) _Synth_PLAY_WAV_redirect->_release();
		_Synth_PLAY_WAV_redirect = base;
		_SynthModule_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline Synth_PLAY_WAV_base *_Synth_PLAY_WAV_base() {
		if(_Synth_PLAY_WAV_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _Synth_PLAY_WAV_redirect;
	}

public:
	inline Synth_PLAY_WAV() : SynthModule(), _Synth_PLAY_WAV_redirect(0) { /* nothing to be done*/ }
	virtual ~Synth_PLAY_WAV();
	inline Synth_PLAY_WAV(const SubClass &s) : SynthModule(), _Synth_PLAY_WAV_redirect(0) {
		_assign_Synth_PLAY_WAV_base(Synth_PLAY_WAV_base::_create(s.string()));
	}
	inline Synth_PLAY_WAV(const Reference &r) : SynthModule(), _Synth_PLAY_WAV_redirect(0) {
		_assign_Synth_PLAY_WAV_base(r.isString()?(Synth_PLAY_WAV_base::_fromString(r.string())):(Synth_PLAY_WAV_base::_fromReference(r.reference(),true)));
	}
	inline Synth_PLAY_WAV(Synth_PLAY_WAV& target) : SynthModule(), _Synth_PLAY_WAV_redirect(0) {
		if (target._Synth_PLAY_WAV_redirect)
			_assign_Synth_PLAY_WAV_base(target._Synth_PLAY_WAV_base()->_copy());
	}
	inline Synth_PLAY_WAV& operator=(Synth_PLAY_WAV& target) {		if (target._Synth_PLAY_WAV_redirect)
			_assign_Synth_PLAY_WAV_base(target._Synth_PLAY_WAV_base()->_copy());
		return *this;
	}
	inline Synth_PLAY_WAV(Synth_PLAY_WAV_base *target) : SynthModule(), _Synth_PLAY_WAV_redirect(0) {
		if (target) _assign_Synth_PLAY_WAV_base(target->_copy());
	}
	inline Synth_PLAY_WAV& operator=(Synth_PLAY_WAV_base *target) {
		if (target) _assign_Synth_PLAY_WAV_base(target->_copy());
		return *this;
	}
	inline Synth_PLAY_WAV(Synth_PLAY_WAV_var target) : SynthModule(), _Synth_PLAY_WAV_redirect(0) {
		if ((Synth_PLAY_WAV_base *)target) _assign_Synth_PLAY_WAV_base(target->_copy());
	}
	inline Synth_PLAY_WAV& operator=(Synth_PLAY_WAV_var target) {
		if ((Synth_PLAY_WAV_base *)target) _assign_Synth_PLAY_WAV_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _Synth_PLAY_WAV_base()->_toString();}
	inline operator Synth_PLAY_WAV_base*() {return _Synth_PLAY_WAV_base();}
	inline bool isNull() {return _Synth_PLAY_WAV_base()==0;}

	inline void start() {_Synth_PLAY_WAV_base()->_node()->start();}
	ScheduleNode *node();

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

	float speed() {return _Synth_PLAY_WAV_base()->speed();}
	void speed(float newValue) {_Synth_PLAY_WAV_base()->speed(newValue);}
	std::string filename() {return _Synth_PLAY_WAV_base()->filename();}
	void filename(const std::string& newValue) {_Synth_PLAY_WAV_base()->filename(newValue);}
	bool finished() {return _Synth_PLAY_WAV_base()->finished();}
};

class ByteStreamToAudio_base : virtual public SynthModule_base {
public:
	static ByteStreamToAudio_base *_create(const std::string& subClass = "ByteStreamToAudio");
	static ByteStreamToAudio_base *_fromString(std::string objectref);
	static ByteStreamToAudio_base *_fromReference(ObjectReference ref, bool needcopy);

	inline ByteStreamToAudio_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual long samplingRate() = 0;
	virtual void samplingRate(long newValue) = 0;
	virtual long channels() = 0;
	virtual void channels(long newValue) = 0;
	virtual long bits() = 0;
	virtual void bits(long newValue) = 0;
	virtual bool running() = 0;
};

typedef ReferenceHelper<ByteStreamToAudio_base> ByteStreamToAudio_var;

class ByteStreamToAudio_stub : virtual public ByteStreamToAudio_base, virtual public SynthModule_stub {
protected:
	ByteStreamToAudio_stub();

public:
	ByteStreamToAudio_stub(Connection *connection, long objectID);

	long samplingRate();
	void samplingRate(long newValue);
	long channels();
	void channels(long newValue);
	long bits();
	void bits(long newValue);
	bool running();
};

class ByteStreamToAudio_skel : virtual public ByteStreamToAudio_base, virtual public SynthModule_skel {
protected:
	// variables for streams
	ByteAsyncStream indata;                   // incoming stream
	float *left;                              // outgoing stream
	float *right;                             // outgoing stream

	// handler for asynchronous streams
	virtual void process_indata(DataPacket<mcopbyte> *) = 0;

public:
	ByteStreamToAudio_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
	void notify(const Notification& notification);
};

#include "reference.h"
#include "flowsystem.h"
#include "component.h"

class ByteStreamToAudio : virtual public Component, virtual public SynthModule {
protected:
	ByteStreamToAudio_base *_ByteStreamToAudio_redirect;

	inline void _assign_ByteStreamToAudio_base(ByteStreamToAudio_base *base) {
		if(_ByteStreamToAudio_redirect != 0) _ByteStreamToAudio_redirect->_release();
		_ByteStreamToAudio_redirect = base;
		_SynthModule_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline ByteStreamToAudio_base *_ByteStreamToAudio_base() {
		if(_ByteStreamToAudio_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _ByteStreamToAudio_redirect;
	}

public:
	inline ByteStreamToAudio() : SynthModule(), _ByteStreamToAudio_redirect(0) { /* nothing to be done*/ }
	virtual ~ByteStreamToAudio();
	inline ByteStreamToAudio(const SubClass &s) : SynthModule(), _ByteStreamToAudio_redirect(0) {
		_assign_ByteStreamToAudio_base(ByteStreamToAudio_base::_create(s.string()));
	}
	inline ByteStreamToAudio(const Reference &r) : SynthModule(), _ByteStreamToAudio_redirect(0) {
		_assign_ByteStreamToAudio_base(r.isString()?(ByteStreamToAudio_base::_fromString(r.string())):(ByteStreamToAudio_base::_fromReference(r.reference(),true)));
	}
	inline ByteStreamToAudio(ByteStreamToAudio& target) : SynthModule(), _ByteStreamToAudio_redirect(0) {
		if (target._ByteStreamToAudio_redirect)
			_assign_ByteStreamToAudio_base(target._ByteStreamToAudio_base()->_copy());
	}
	inline ByteStreamToAudio& operator=(ByteStreamToAudio& target) {		if (target._ByteStreamToAudio_redirect)
			_assign_ByteStreamToAudio_base(target._ByteStreamToAudio_base()->_copy());
		return *this;
	}
	inline ByteStreamToAudio(ByteStreamToAudio_base *target) : SynthModule(), _ByteStreamToAudio_redirect(0) {
		if (target) _assign_ByteStreamToAudio_base(target->_copy());
	}
	inline ByteStreamToAudio& operator=(ByteStreamToAudio_base *target) {
		if (target) _assign_ByteStreamToAudio_base(target->_copy());
		return *this;
	}
	inline ByteStreamToAudio(ByteStreamToAudio_var target) : SynthModule(), _ByteStreamToAudio_redirect(0) {
		if ((ByteStreamToAudio_base *)target) _assign_ByteStreamToAudio_base(target->_copy());
	}
	inline ByteStreamToAudio& operator=(ByteStreamToAudio_var target) {
		if ((ByteStreamToAudio_base *)target) _assign_ByteStreamToAudio_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _ByteStreamToAudio_base()->_toString();}
	inline operator ByteStreamToAudio_base*() {return _ByteStreamToAudio_base();}
	inline bool isNull() {return _ByteStreamToAudio_base()==0;}

	inline void start() {_ByteStreamToAudio_base()->_node()->start();}
	ScheduleNode *node();

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

	long samplingRate() {return _ByteStreamToAudio_base()->samplingRate();}
	void samplingRate(long newValue) {_ByteStreamToAudio_base()->samplingRate(newValue);}
	long channels() {return _ByteStreamToAudio_base()->channels();}
	void channels(long newValue) {_ByteStreamToAudio_base()->channels(newValue);}
	long bits() {return _ByteStreamToAudio_base()->bits();}
	void bits(long newValue) {_ByteStreamToAudio_base()->bits(newValue);}
	bool running() {return _ByteStreamToAudio_base()->running();}
};

class StereoEffect_base : virtual public SynthModule_base {
public:
	static StereoEffect_base *_create(const std::string& subClass = "StereoEffect");
	static StereoEffect_base *_fromString(std::string objectref);
	static StereoEffect_base *_fromReference(ObjectReference ref, bool needcopy);

	inline StereoEffect_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

};

typedef ReferenceHelper<StereoEffect_base> StereoEffect_var;

class StereoEffect_stub : virtual public StereoEffect_base, virtual public SynthModule_stub {
protected:
	StereoEffect_stub();

public:
	StereoEffect_stub(Connection *connection, long objectID);

};

class StereoEffect_skel : virtual public StereoEffect_base, virtual public SynthModule_skel {
protected:
	// variables for streams
	float *inleft;                            // incoming stream
	float *inright;                           // incoming stream
	float *outleft;                           // outgoing stream
	float *outright;                          // outgoing stream

public:
	StereoEffect_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"
#include "flowsystem.h"
#include "component.h"

class StereoEffect : virtual public Component, virtual public SynthModule {
protected:
	StereoEffect_base *_StereoEffect_redirect;

	inline void _assign_StereoEffect_base(StereoEffect_base *base) {
		if(_StereoEffect_redirect != 0) _StereoEffect_redirect->_release();
		_StereoEffect_redirect = base;
		_SynthModule_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline StereoEffect_base *_StereoEffect_base() {
		if(_StereoEffect_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _StereoEffect_redirect;
	}

public:
	inline StereoEffect() : SynthModule(), _StereoEffect_redirect(0) { /* nothing to be done*/ }
	virtual ~StereoEffect();
	inline StereoEffect(const SubClass &s) : SynthModule(), _StereoEffect_redirect(0) {
		_assign_StereoEffect_base(StereoEffect_base::_create(s.string()));
	}
	inline StereoEffect(const Reference &r) : SynthModule(), _StereoEffect_redirect(0) {
		_assign_StereoEffect_base(r.isString()?(StereoEffect_base::_fromString(r.string())):(StereoEffect_base::_fromReference(r.reference(),true)));
	}
	inline StereoEffect(StereoEffect& target) : SynthModule(), _StereoEffect_redirect(0) {
		if (target._StereoEffect_redirect)
			_assign_StereoEffect_base(target._StereoEffect_base()->_copy());
	}
	inline StereoEffect& operator=(StereoEffect& target) {		if (target._StereoEffect_redirect)
			_assign_StereoEffect_base(target._StereoEffect_base()->_copy());
		return *this;
	}
	inline StereoEffect(StereoEffect_base *target) : SynthModule(), _StereoEffect_redirect(0) {
		if (target) _assign_StereoEffect_base(target->_copy());
	}
	inline StereoEffect& operator=(StereoEffect_base *target) {
		if (target) _assign_StereoEffect_base(target->_copy());
		return *this;
	}
	inline StereoEffect(StereoEffect_var target) : SynthModule(), _StereoEffect_redirect(0) {
		if ((StereoEffect_base *)target) _assign_StereoEffect_base(target->_copy());
	}
	inline StereoEffect& operator=(StereoEffect_var target) {
		if ((StereoEffect_base *)target) _assign_StereoEffect_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _StereoEffect_base()->_toString();}
	inline operator StereoEffect_base*() {return _StereoEffect_base();}
	inline bool isNull() {return _StereoEffect_base()==0;}

	inline void start() {_StereoEffect_base()->_node()->start();}
	ScheduleNode *node();

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

};

class StereoVolumeControl_base : virtual public StereoEffect_base {
public:
	static StereoVolumeControl_base *_create(const std::string& subClass = "StereoVolumeControl");
	static StereoVolumeControl_base *_fromString(std::string objectref);
	static StereoVolumeControl_base *_fromReference(ObjectReference ref, bool needcopy);

	inline StereoVolumeControl_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual float scaleFactor() = 0;
	virtual void scaleFactor(float newValue) = 0;
	virtual float currentVolumeLeft() = 0;
	virtual float currentVolumeRight() = 0;
};

typedef ReferenceHelper<StereoVolumeControl_base> StereoVolumeControl_var;

class StereoVolumeControl_stub : virtual public StereoVolumeControl_base, virtual public StereoEffect_stub {
protected:
	StereoVolumeControl_stub();

public:
	StereoVolumeControl_stub(Connection *connection, long objectID);

	float scaleFactor();
	void scaleFactor(float newValue);
	float currentVolumeLeft();
	float currentVolumeRight();
};

class StereoVolumeControl_skel : virtual public StereoVolumeControl_base, virtual public StereoEffect_skel {
public:
	StereoVolumeControl_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class StereoVolumeControl : virtual public StereoEffect {
protected:
	StereoVolumeControl_base *_StereoVolumeControl_redirect;

	inline void _assign_StereoVolumeControl_base(StereoVolumeControl_base *base) {
		if(_StereoVolumeControl_redirect != 0) _StereoVolumeControl_redirect->_release();
		_StereoVolumeControl_redirect = base;
		_StereoEffect_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline StereoVolumeControl_base *_StereoVolumeControl_base() {
		if(_StereoVolumeControl_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _StereoVolumeControl_redirect;
	}

public:
	inline StereoVolumeControl() : StereoEffect(), _StereoVolumeControl_redirect(0) { /* nothing to be done*/ }
	virtual ~StereoVolumeControl();
	inline StereoVolumeControl(const SubClass &s) : StereoEffect(), _StereoVolumeControl_redirect(0) {
		_assign_StereoVolumeControl_base(StereoVolumeControl_base::_create(s.string()));
	}
	inline StereoVolumeControl(const Reference &r) : StereoEffect(), _StereoVolumeControl_redirect(0) {
		_assign_StereoVolumeControl_base(r.isString()?(StereoVolumeControl_base::_fromString(r.string())):(StereoVolumeControl_base::_fromReference(r.reference(),true)));
	}
	inline StereoVolumeControl(StereoVolumeControl& target) : StereoEffect(), _StereoVolumeControl_redirect(0) {
		if (target._StereoVolumeControl_redirect)
			_assign_StereoVolumeControl_base(target._StereoVolumeControl_base()->_copy());
	}
	inline StereoVolumeControl& operator=(StereoVolumeControl& target) {		if (target._StereoVolumeControl_redirect)
			_assign_StereoVolumeControl_base(target._StereoVolumeControl_base()->_copy());
		return *this;
	}
	inline StereoVolumeControl(StereoVolumeControl_base *target) : StereoEffect(), _StereoVolumeControl_redirect(0) {
		if (target) _assign_StereoVolumeControl_base(target->_copy());
	}
	inline StereoVolumeControl& operator=(StereoVolumeControl_base *target) {
		if (target) _assign_StereoVolumeControl_base(target->_copy());
		return *this;
	}
	inline StereoVolumeControl(StereoVolumeControl_var target) : StereoEffect(), _StereoVolumeControl_redirect(0) {
		if ((StereoVolumeControl_base *)target) _assign_StereoVolumeControl_base(target->_copy());
	}
	inline StereoVolumeControl& operator=(StereoVolumeControl_var target) {
		if ((StereoVolumeControl_base *)target) _assign_StereoVolumeControl_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _StereoVolumeControl_base()->_toString();}
	inline operator StereoVolumeControl_base*() {return _StereoVolumeControl_base();}
	inline bool isNull() {return _StereoVolumeControl_base()==0;}

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

	float scaleFactor() {return _StereoVolumeControl_base()->scaleFactor();}
	void scaleFactor(float newValue) {_StereoVolumeControl_base()->scaleFactor(newValue);}
	float currentVolumeLeft() {return _StereoVolumeControl_base()->currentVolumeLeft();}
	float currentVolumeRight() {return _StereoVolumeControl_base()->currentVolumeRight();}
};

class StereoFFTScope_base : virtual public StereoEffect_base {
public:
	static StereoFFTScope_base *_create(const std::string& subClass = "StereoFFTScope");
	static StereoFFTScope_base *_fromString(std::string objectref);
	static StereoFFTScope_base *_fromReference(ObjectReference ref, bool needcopy);

	inline StereoFFTScope_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual std::vector<float> * scope() = 0;
};

typedef ReferenceHelper<StereoFFTScope_base> StereoFFTScope_var;

class StereoFFTScope_stub : virtual public StereoFFTScope_base, virtual public StereoEffect_stub {
protected:
	StereoFFTScope_stub();

public:
	StereoFFTScope_stub(Connection *connection, long objectID);

	std::vector<float> * scope();
};

class StereoFFTScope_skel : virtual public StereoFFTScope_base, virtual public StereoEffect_skel {
public:
	StereoFFTScope_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class StereoFFTScope : virtual public StereoEffect {
protected:
	StereoFFTScope_base *_StereoFFTScope_redirect;

	inline void _assign_StereoFFTScope_base(StereoFFTScope_base *base) {
		if(_StereoFFTScope_redirect != 0) _StereoFFTScope_redirect->_release();
		_StereoFFTScope_redirect = base;
		_StereoEffect_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline StereoFFTScope_base *_StereoFFTScope_base() {
		if(_StereoFFTScope_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _StereoFFTScope_redirect;
	}

public:
	inline StereoFFTScope() : StereoEffect(), _StereoFFTScope_redirect(0) { /* nothing to be done*/ }
	virtual ~StereoFFTScope();
	inline StereoFFTScope(const SubClass &s) : StereoEffect(), _StereoFFTScope_redirect(0) {
		_assign_StereoFFTScope_base(StereoFFTScope_base::_create(s.string()));
	}
	inline StereoFFTScope(const Reference &r) : StereoEffect(), _StereoFFTScope_redirect(0) {
		_assign_StereoFFTScope_base(r.isString()?(StereoFFTScope_base::_fromString(r.string())):(StereoFFTScope_base::_fromReference(r.reference(),true)));
	}
	inline StereoFFTScope(StereoFFTScope& target) : StereoEffect(), _StereoFFTScope_redirect(0) {
		if (target._StereoFFTScope_redirect)
			_assign_StereoFFTScope_base(target._StereoFFTScope_base()->_copy());
	}
	inline StereoFFTScope& operator=(StereoFFTScope& target) {		if (target._StereoFFTScope_redirect)
			_assign_StereoFFTScope_base(target._StereoFFTScope_base()->_copy());
		return *this;
	}
	inline StereoFFTScope(StereoFFTScope_base *target) : StereoEffect(), _StereoFFTScope_redirect(0) {
		if (target) _assign_StereoFFTScope_base(target->_copy());
	}
	inline StereoFFTScope& operator=(StereoFFTScope_base *target) {
		if (target) _assign_StereoFFTScope_base(target->_copy());
		return *this;
	}
	inline StereoFFTScope(StereoFFTScope_var target) : StereoEffect(), _StereoFFTScope_redirect(0) {
		if ((StereoFFTScope_base *)target) _assign_StereoFFTScope_base(target->_copy());
	}
	inline StereoFFTScope& operator=(StereoFFTScope_var target) {
		if ((StereoFFTScope_base *)target) _assign_StereoFFTScope_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _StereoFFTScope_base()->_toString();}
	inline operator StereoFFTScope_base*() {return _StereoFFTScope_base();}
	inline bool isNull() {return _StereoFFTScope_base()==0;}

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

	std::vector<float> * scope() {return _StereoFFTScope_base()->scope();}
};

class StereoEffectStack_base : virtual public SynthModule_base {
public:
	static StereoEffectStack_base *_create(const std::string& subClass = "StereoEffectStack");
	static StereoEffectStack_base *_fromString(std::string objectref);
	static StereoEffectStack_base *_fromReference(ObjectReference ref, bool needcopy);

	inline StereoEffectStack_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual void setInputs(Object_base * leftObj, const std::string& leftPort, Object_base * rightObj, const std::string& rightPort) = 0;
	virtual void setOutputs(Object_base * leftObj, const std::string& leftPort, Object_base * rightObj, const std::string& rightPort) = 0;
	virtual long insertTop(StereoEffect_base * effect, const std::string& name) = 0;
	virtual long insertBottom(StereoEffect_base * effect, const std::string& name) = 0;
	virtual void remove(long ID) = 0;
};

typedef ReferenceHelper<StereoEffectStack_base> StereoEffectStack_var;

class StereoEffectStack_stub : virtual public StereoEffectStack_base, virtual public SynthModule_stub {
protected:
	StereoEffectStack_stub();

public:
	StereoEffectStack_stub(Connection *connection, long objectID);

	void setInputs(Object_base * leftObj, const std::string& leftPort, Object_base * rightObj, const std::string& rightPort);
	void setOutputs(Object_base * leftObj, const std::string& leftPort, Object_base * rightObj, const std::string& rightPort);
	long insertTop(StereoEffect_base * effect, const std::string& name);
	long insertBottom(StereoEffect_base * effect, const std::string& name);
	void remove(long ID);
};

class StereoEffectStack_skel : virtual public StereoEffectStack_base, virtual public SynthModule_skel {
public:
	StereoEffectStack_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class StereoEffectStack : virtual public SynthModule {
protected:
	StereoEffectStack_base *_StereoEffectStack_redirect;

	inline void _assign_StereoEffectStack_base(StereoEffectStack_base *base) {
		if(_StereoEffectStack_redirect != 0) _StereoEffectStack_redirect->_release();
		_StereoEffectStack_redirect = base;
		_SynthModule_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline StereoEffectStack_base *_StereoEffectStack_base() {
		if(_StereoEffectStack_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _StereoEffectStack_redirect;
	}

public:
	inline StereoEffectStack() : SynthModule(), _StereoEffectStack_redirect(0) { /* nothing to be done*/ }
	virtual ~StereoEffectStack();
	inline StereoEffectStack(const SubClass &s) : SynthModule(), _StereoEffectStack_redirect(0) {
		_assign_StereoEffectStack_base(StereoEffectStack_base::_create(s.string()));
	}
	inline StereoEffectStack(const Reference &r) : SynthModule(), _StereoEffectStack_redirect(0) {
		_assign_StereoEffectStack_base(r.isString()?(StereoEffectStack_base::_fromString(r.string())):(StereoEffectStack_base::_fromReference(r.reference(),true)));
	}
	inline StereoEffectStack(StereoEffectStack& target) : SynthModule(), _StereoEffectStack_redirect(0) {
		if (target._StereoEffectStack_redirect)
			_assign_StereoEffectStack_base(target._StereoEffectStack_base()->_copy());
	}
	inline StereoEffectStack& operator=(StereoEffectStack& target) {		if (target._StereoEffectStack_redirect)
			_assign_StereoEffectStack_base(target._StereoEffectStack_base()->_copy());
		return *this;
	}
	inline StereoEffectStack(StereoEffectStack_base *target) : SynthModule(), _StereoEffectStack_redirect(0) {
		if (target) _assign_StereoEffectStack_base(target->_copy());
	}
	inline StereoEffectStack& operator=(StereoEffectStack_base *target) {
		if (target) _assign_StereoEffectStack_base(target->_copy());
		return *this;
	}
	inline StereoEffectStack(StereoEffectStack_var target) : SynthModule(), _StereoEffectStack_redirect(0) {
		if ((StereoEffectStack_base *)target) _assign_StereoEffectStack_base(target->_copy());
	}
	inline StereoEffectStack& operator=(StereoEffectStack_var target) {
		if ((StereoEffectStack_base *)target) _assign_StereoEffectStack_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _StereoEffectStack_base()->_toString();}
	inline operator StereoEffectStack_base*() {return _StereoEffectStack_base();}
	inline bool isNull() {return _StereoEffectStack_base()==0;}

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

	inline void setInputs(Object_base * leftObj, const std::string& leftPort, Object_base * rightObj, const std::string& rightPort) {return _StereoEffectStack_base()->setInputs(leftObj, leftPort, rightObj, rightPort);}
	inline void setOutputs(Object_base * leftObj, const std::string& leftPort, Object_base * rightObj, const std::string& rightPort) {return _StereoEffectStack_base()->setOutputs(leftObj, leftPort, rightObj, rightPort);}
	inline long insertTop(StereoEffect& effect, const std::string& name) {return _StereoEffectStack_base()->insertTop(effect, name);}
	inline long insertTop(StereoEffect_var effect, const std::string& name) {return _StereoEffectStack_base()->insertTop(effect, name);}
	inline long insertBottom(StereoEffect& effect, const std::string& name) {return _StereoEffectStack_base()->insertBottom(effect, name);}
	inline long insertBottom(StereoEffect_var effect, const std::string& name) {return _StereoEffectStack_base()->insertBottom(effect, name);}
	inline void remove(long ID) {return _StereoEffectStack_base()->remove(ID);}
};

#endif /* ARTSFLOW_H */
