/* this file was generated by the MCOP idl compiler - DO NOT EDIT */

#ifndef KMEDIA2_H
#define KMEDIA2_H

#include "common.h"

enum poState {posPlaying = 0, posFinished = 1, posPaused = 2};
enum poCapabilities {capSeek = 1, capPause = 2};
class poTime : public Type {
public:
	poTime();
	poTime(long ms, long seconds, float custom, const std::string& customUnit);
	poTime(Buffer& stream);
	poTime(const poTime& copyType);
	poTime& operator=(const poTime& assignType);
	virtual ~poTime();

	long ms;
	long seconds;
	float custom;
	std::string customUnit;

// marshalling functions
	void readType(Buffer& stream);
	void writeType(Buffer& stream) const;
};

class PlayObject_private_base : virtual public Object {
public:
	static PlayObject_private_base *_create(const std::string& subClass = "PlayObject_private");
	static PlayObject_private_base *_fromString(std::string objectref);
	static PlayObject_private_base *_fromReference(ObjectReference ref, bool needcopy);

	inline PlayObject_private_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual bool loadMedia(const std::string& filename) = 0;
};

typedef ReferenceHelper<PlayObject_private_base> PlayObject_private_var;

class PlayObject_private_stub : virtual public PlayObject_private_base, virtual public Object_stub {
protected:
	PlayObject_private_stub();

public:
	PlayObject_private_stub(Connection *connection, long objectID);

	bool loadMedia(const std::string& filename);
};

class PlayObject_private_skel : virtual public PlayObject_private_base, virtual public Object_skel {
public:
	PlayObject_private_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class PlayObject_private : virtual public SmartWrapper {
protected:
	PlayObject_private_base *_PlayObject_private_redirect;

	inline void _assign_PlayObject_private_base(PlayObject_private_base *base) {
		if(_PlayObject_private_redirect != 0) _PlayObject_private_redirect->_release();
		_PlayObject_private_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline PlayObject_private_base *_PlayObject_private_base() {
		if(_PlayObject_private_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _PlayObject_private_redirect;
	}

public:
	inline PlayObject_private() : _PlayObject_private_redirect(0) { /* nothing to be done*/ }
	virtual ~PlayObject_private();
	inline PlayObject_private(const SubClass &s) : _PlayObject_private_redirect(0) {
		_assign_PlayObject_private_base(PlayObject_private_base::_create(s.string()));
	}
	inline PlayObject_private(const Reference &r) : _PlayObject_private_redirect(0) {
		_assign_PlayObject_private_base(r.isString()?(PlayObject_private_base::_fromString(r.string())):(PlayObject_private_base::_fromReference(r.reference(),true)));
	}
	inline PlayObject_private(PlayObject_private& target) : _PlayObject_private_redirect(0) {
		if (target._PlayObject_private_redirect)
			_assign_PlayObject_private_base(target._PlayObject_private_base()->_copy());
	}
	inline PlayObject_private& operator=(PlayObject_private& target) {		if (target._PlayObject_private_redirect)
			_assign_PlayObject_private_base(target._PlayObject_private_base()->_copy());
		return *this;
	}
	inline PlayObject_private(PlayObject_private_base *target) : _PlayObject_private_redirect(0) {
		if (target) _assign_PlayObject_private_base(target->_copy());
	}
	inline PlayObject_private& operator=(PlayObject_private_base *target) {
		if (target) _assign_PlayObject_private_base(target->_copy());
		return *this;
	}
	inline PlayObject_private(PlayObject_private_var target) : _PlayObject_private_redirect(0) {
		if ((PlayObject_private_base *)target) _assign_PlayObject_private_base(target->_copy());
	}
	inline PlayObject_private& operator=(PlayObject_private_var target) {
		if ((PlayObject_private_base *)target) _assign_PlayObject_private_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _PlayObject_private_base()->_toString();}
	inline operator PlayObject_private_base*() {return _PlayObject_private_base();}
	inline bool isNull() {return _PlayObject_private_base()==0;}

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

	inline bool loadMedia(const std::string& filename) {return _PlayObject_private_base()->loadMedia(filename);}
};

class PlayObject_base : virtual public PlayObject_private_base {
public:
	static PlayObject_base *_create(const std::string& subClass = "PlayObject");
	static PlayObject_base *_fromString(std::string objectref);
	static PlayObject_base *_fromReference(ObjectReference ref, bool needcopy);

	inline PlayObject_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual std::string description() = 0;
	virtual void description(const std::string& newValue) = 0;
	virtual poTime* currentTime() = 0;
	virtual void currentTime(const poTime& newValue) = 0;
	virtual poTime* overallTime() = 0;
	virtual poCapabilities capabilities() = 0;
	virtual std::string mediaName() = 0;
	virtual poState state() = 0;
	virtual void play() = 0;
	virtual void seek(const poTime& newTime) = 0;
	virtual void pause() = 0;
};

typedef ReferenceHelper<PlayObject_base> PlayObject_var;

class PlayObject_stub : virtual public PlayObject_base, virtual public PlayObject_private_stub {
protected:
	PlayObject_stub();

public:
	PlayObject_stub(Connection *connection, long objectID);

	std::string description();
	void description(const std::string& newValue);
	poTime* currentTime();
	void currentTime(const poTime& newValue);
	poTime* overallTime();
	poCapabilities capabilities();
	std::string mediaName();
	poState state();
	void play();
	void seek(const poTime& newTime);
	void pause();
};

class PlayObject_skel : virtual public PlayObject_base, virtual public PlayObject_private_skel {
public:
	PlayObject_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class PlayObject : virtual public PlayObject_private {
protected:
	PlayObject_base *_PlayObject_redirect;

	inline void _assign_PlayObject_base(PlayObject_base *base) {
		if(_PlayObject_redirect != 0) _PlayObject_redirect->_release();
		_PlayObject_redirect = base;
		_PlayObject_private_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline PlayObject_base *_PlayObject_base() {
		if(_PlayObject_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _PlayObject_redirect;
	}

public:
	inline PlayObject() : PlayObject_private(), _PlayObject_redirect(0) { /* nothing to be done*/ }
	virtual ~PlayObject();
	inline PlayObject(const SubClass &s) : PlayObject_private(), _PlayObject_redirect(0) {
		_assign_PlayObject_base(PlayObject_base::_create(s.string()));
	}
	inline PlayObject(const Reference &r) : PlayObject_private(), _PlayObject_redirect(0) {
		_assign_PlayObject_base(r.isString()?(PlayObject_base::_fromString(r.string())):(PlayObject_base::_fromReference(r.reference(),true)));
	}
	inline PlayObject(PlayObject& target) : PlayObject_private(), _PlayObject_redirect(0) {
		if (target._PlayObject_redirect)
			_assign_PlayObject_base(target._PlayObject_base()->_copy());
	}
	inline PlayObject& operator=(PlayObject& target) {		if (target._PlayObject_redirect)
			_assign_PlayObject_base(target._PlayObject_base()->_copy());
		return *this;
	}
	inline PlayObject(PlayObject_base *target) : PlayObject_private(), _PlayObject_redirect(0) {
		if (target) _assign_PlayObject_base(target->_copy());
	}
	inline PlayObject& operator=(PlayObject_base *target) {
		if (target) _assign_PlayObject_base(target->_copy());
		return *this;
	}
	inline PlayObject(PlayObject_var target) : PlayObject_private(), _PlayObject_redirect(0) {
		if ((PlayObject_base *)target) _assign_PlayObject_base(target->_copy());
	}
	inline PlayObject& operator=(PlayObject_var target) {
		if ((PlayObject_base *)target) _assign_PlayObject_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _PlayObject_base()->_toString();}
	inline operator PlayObject_base*() {return _PlayObject_base();}
	inline bool isNull() {return _PlayObject_base()==0;}

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

	std::string description() {return _PlayObject_base()->description();}
	void description(const std::string& newValue) {_PlayObject_base()->description(newValue);}
	poTime* currentTime() {return _PlayObject_base()->currentTime();}
	void currentTime(const poTime& newValue) {_PlayObject_base()->currentTime(newValue);}
	poTime* overallTime() {return _PlayObject_base()->overallTime();}
	poCapabilities capabilities() {return _PlayObject_base()->capabilities();}
	std::string mediaName() {return _PlayObject_base()->mediaName();}
	poState state() {return _PlayObject_base()->state();}
	inline void play() {return _PlayObject_base()->play();}
	inline void seek(const poTime& newTime) {return _PlayObject_base()->seek(newTime);}
	inline void pause() {return _PlayObject_base()->pause();}
};

class PlayObjectFactory_base : virtual public Object {
public:
	static PlayObjectFactory_base *_create(const std::string& subClass = "PlayObjectFactory");
	static PlayObjectFactory_base *_fromString(std::string objectref);
	static PlayObjectFactory_base *_fromReference(ObjectReference ref, bool needcopy);

	inline PlayObjectFactory_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual PlayObject_base * createPlayObject(const std::string& filename) = 0;
};

typedef ReferenceHelper<PlayObjectFactory_base> PlayObjectFactory_var;

class PlayObjectFactory_stub : virtual public PlayObjectFactory_base, virtual public Object_stub {
protected:
	PlayObjectFactory_stub();

public:
	PlayObjectFactory_stub(Connection *connection, long objectID);

	PlayObject_base * createPlayObject(const std::string& filename);
};

class PlayObjectFactory_skel : virtual public PlayObjectFactory_base, virtual public Object_skel {
public:
	PlayObjectFactory_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void *_cast(std::string interface);
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class PlayObjectFactory : virtual public SmartWrapper {
protected:
	PlayObjectFactory_base *_PlayObjectFactory_redirect;

	inline void _assign_PlayObjectFactory_base(PlayObjectFactory_base *base) {
		if(_PlayObjectFactory_redirect != 0) _PlayObjectFactory_redirect->_release();
		_PlayObjectFactory_redirect = base;
		_autoCreate = false;
	}
	virtual void _create();
	inline PlayObjectFactory_base *_PlayObjectFactory_base() {
		if(_PlayObjectFactory_redirect == 0 && _autoCreate) _create();  // lazy on-demand creation
		return _PlayObjectFactory_redirect;
	}

public:
	inline PlayObjectFactory() : _PlayObjectFactory_redirect(0) { /* nothing to be done*/ }
	virtual ~PlayObjectFactory();
	inline PlayObjectFactory(const SubClass &s) : _PlayObjectFactory_redirect(0) {
		_assign_PlayObjectFactory_base(PlayObjectFactory_base::_create(s.string()));
	}
	inline PlayObjectFactory(const Reference &r) : _PlayObjectFactory_redirect(0) {
		_assign_PlayObjectFactory_base(r.isString()?(PlayObjectFactory_base::_fromString(r.string())):(PlayObjectFactory_base::_fromReference(r.reference(),true)));
	}
	inline PlayObjectFactory(PlayObjectFactory& target) : _PlayObjectFactory_redirect(0) {
		if (target._PlayObjectFactory_redirect)
			_assign_PlayObjectFactory_base(target._PlayObjectFactory_base()->_copy());
	}
	inline PlayObjectFactory& operator=(PlayObjectFactory& target) {		if (target._PlayObjectFactory_redirect)
			_assign_PlayObjectFactory_base(target._PlayObjectFactory_base()->_copy());
		return *this;
	}
	inline PlayObjectFactory(PlayObjectFactory_base *target) : _PlayObjectFactory_redirect(0) {
		if (target) _assign_PlayObjectFactory_base(target->_copy());
	}
	inline PlayObjectFactory& operator=(PlayObjectFactory_base *target) {
		if (target) _assign_PlayObjectFactory_base(target->_copy());
		return *this;
	}
	inline PlayObjectFactory(PlayObjectFactory_var target) : _PlayObjectFactory_redirect(0) {
		if ((PlayObjectFactory_base *)target) _assign_PlayObjectFactory_base(target->_copy());
	}
	inline PlayObjectFactory& operator=(PlayObjectFactory_var target) {
		if ((PlayObjectFactory_base *)target) _assign_PlayObjectFactory_base(target->_copy());
		return *this;
	}
	inline std::string toString() {return _PlayObjectFactory_base()->_toString();}
	inline operator PlayObjectFactory_base*() {return _PlayObjectFactory_base();}
	inline bool isNull() {return _PlayObjectFactory_base()==0;}

	virtual vector<std::string> defaultPortsIn();
	virtual vector<std::string> defaultPortsOut();

	inline PlayObject createPlayObject(const std::string& filename) {return _PlayObjectFactory_base()->createPlayObject(filename);}
};

#endif /* KMEDIA2_H */
